[ACM] hdu 5045 Contest (减少国家Dp)

[ACM] hdu 5045 Contest (减少国家Dp)

大家好,又见面了,我是全栈君,今天给大家准备了Idea注册码。

Contest

Problem Description
In the ACM International Collegiate Programming Contest, each team consist of three students. And the teams are given 5 hours to solve between 8 and 12 programming problems.

On Mars, there is programming contest, too. Each team consist of N students. The teams are given M hours to solve M programming problems. Each team can use only one computer, but they can’t cooperate to solve a problem. At the beginning of the ith hour, they will get the ith programming problem. They must choose a student to solve this problem and others go out to have a rest. The chosen student will spend an hour time to program this problem. At the end of this hour, he must submit his program. This program is then run on test data and can’t modify any more.

Now, you have to help a team to find a strategy to maximize the expected number of correctly solved problems.

For each problem, each student has a certain probability that correct solve. If the i
th student solve the j
th problem, the probability of correct solve is P
ij .

At any time, the different between any two students’ programming time is not more than 1 hour. For example, if there are 3 students and there are 5 problems. The strategy {1,2,3,1,2}, {1,3,2,2,3} or {2,1,3,3,1} are all legal. But {1,1,3,2,3},{3,1,3,1,2} and {1,2,3,1,1} are all illegal.

You should find a strategy to maximize the expected number of correctly solved problems, if you have know all probability

 

Input
The first line of the input is T (1 ≤ T ≤ 20), which stands for the number of test cases you need to solve.

The first line of each case contains two integers N ,M (1 ≤ N ≤ 10,1 ≤ M ≤ 1000),denoting the number of students and programming problem, respectively.

The next N lines, each lines contains M real numbers between 0 and 1 , the j
th number in the i
th line is P
ij .

 

Output
For each test case, print a line “Case #t: ”(without quotes, t means the index of the test case) at the beginning. Then a single real number means the maximal expected number of correctly solved problems if this team follow the best strategy, to five digits after the decimal point. Look at the output for sample input for details.
 

Sample Input
   
   
1 2 3 0.6 0.3 0.4 0.3 0.7 0.9

 

Sample Output
   
   
Case #1: 2.20000

 

Source

解题思路:

题意为有n个学生,m道题,已知每位学生对每一个题都有一个答对的可能性,要求一道题目仅仅能一个学生做。一个学生能够做多道。 且随意两个学生之间做的题目之差不能超过1,问m道题所有答对的最大可能性为多少。

n最大为10。所以最多有 0~(2的10次方-1)种状态,每一位代表一个学生。1表示答题。0表示不答题。

当dp[ i ] [ j ]代表前 i  道题,状态为 j 的所有答对最大可能性。状态为j,也就是二进制里面包含i个1,由于要选i个人答题。

比方 dp[ 2 ][ 4],  4 可能是1001 1100 0011  0101等。仅仅要包含2个1就能够。 n<=m的时候

状态转移方程为:  dp [  i +1 ]  [ j ]= max(dp[i+1][j], dp[i-1][ s] + p[ k ][ i ] ) s是一个状态,p[k][i]表示第k个人答对第i道题的可能性

从已知状态推未知状态。

n>m时。由于随意两个学生做的题目仅仅差不能超过1,所以 当全部学生都答过一道题以后,状态要从0開始, dp[i][ (1<<n)-1]已知。也就是dp[i][0]已知

參考:http://www.2cto.com/kf/201409/338936.html

代码:

#include <iostream>
#include <stdio.h>
#include <string.h>
using namespace std;
const int Max=(1<<10)+1;
double dp[1001][Max];//代表前i道题,状态为j做出来题目的最大期望
double p[11][1001];
int n,m;
int s;//最大状态

double  solve()
{
    double ans=-1.0;
    dp[0][0]=0;
    for(int i=0;i<m;i++)//第几道题
        for(int j=0;j<s;j++)
        {
            if(dp[i][j]<0)//眼下该状态还没出现
                continue;
            for(int k=0;k<n;k++)//第几个人来做
            {
                if(!((1<<k)&j))//第k个人可选,也就是j的二进制第k位为0
                {
                    int temps=j|(1<<k);
                    if(temps==(s-1))
                        temps=0;
                    dp[i+1][temps]=max(dp[i+1][temps],dp[i][j]+p[k][i]);
                }
            }
        }
    for(int i=0;i<s;i++)
        if(ans<dp[m][i])
        ans=dp[m][i];
    return ans;
}
int main()
{
    int t;scanf("%d",&t);
    for(int ca=1;ca<=t;ca++)
    {
        scanf("%d%d",&n,&m);
        for(int i=0;i<n;i++)
            for(int j=0;j<m;j++)
            scanf("%lf",&p[i][j]);
        s=1<<n;
        for(int i=0;i<=m;i++)
            for(int j=0;j<s;j++)
            dp[i][j]=-1.0;
        double ans=solve();
        printf("Case #%d: %.5lf\n",ca,ans);
    }
    return 0;
}

版权声明:本文博客原创文章。博客,未经同意,不得转载。

版权声明:本文内容由互联网用户自发贡献,该文观点仅代表作者本人。本站仅提供信息存储空间服务,不拥有所有权,不承担相关法律责任。如发现本站有涉嫌侵权/违法违规的内容, 请发送邮件至 举报,一经查实,本站将立刻删除。

发布者:全栈程序员-用户IM,转载请注明出处:https://javaforall.cn/117680.html原文链接:https://javaforall.cn

【正版授权,激活自己账号】: Jetbrains全家桶Ide使用,1年售后保障,每天仅需1毛

【官方授权 正版激活】: 官方授权 正版激活 支持Jetbrains家族下所有IDE 使用个人JB账号...

(0)


相关推荐

发表回复

您的电子邮箱地址不会被公开。

关注全栈程序员社区公众号